{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit InterCon;

interface

uses Dos,Crt,VdtDisp,VdtTools,Colors,Video60,Stringer,XSer;

const
   MaxMouseCompteur : word = 50;
   StepMouseDelay   : word = 10;

type
     fields_map     = record
                        X    : byte; {  coord champ  }
                        Y    : byte;
                        Long : byte; {  longueur  }
                        Haut : byte; {  hauteur   }
                        Vis  : boolean; {  visible  }
                        NoR  : boolean; {  NoRepeat  }
                      end;

     Fld_map        = record
                        field  : byte; {  champs vrai origine  }
                        Select : boolean; {  si deja 'selectionne'  }
                        save   : boolean; {  field save?  }
                        long   : word; {  only if save = true  }
                        case word of
                          FALSE : (point : pointer);
                          TRUE  : (Ofs,Seg : word);
                          {  adresse de la sauvegarde du champ  }
                      end;

const
     Nbre_fields    = 153; {  nbre de champs  }
     field          : array[1..Nbre_fields] of fields_map = (
(X : 1; Y : 1; Long : 10; Haut : 1; Vis : true; NoR : true),  {  Rserv au "System"  }
(X : 61; Y : 1; Long : 7; Haut : 1; Vis : true; NoR : false), {  MEM.1.: 2  }
(X : 1; Y : 9; Long : 18; Haut : 1; Vis : true; NoR : false), {  trait : 3  }
(X : 1; Y : 10; Long : 18; Haut : 1; Vis : true; NoR : false), {  fond  : 4  }
(X : 1; Y : 11; Long : 18; Haut : 1; Vis : true; NoR : false), {  taille: 5  }
(X : 1; Y : 12; Long : 18; Haut : 1; Vis : true; NoR : true), {  inver.: 6  }
(X : 1; Y : 13; Long : 18; Haut : 1; Vis : true; NoR : true), {  souli.: 7  }
(X : 1; Y : 14; Long : 18; Haut : 1; Vis : true; NoR : true), {  stable: 8  }
(X : 1; Y : 15; Long : 18; Haut : 1; Vis : true; NoR : true), {  Masque: 9  }
(X : 1; Y : 16; Long : 18; Haut : 1; Vis : true; NoR : TRUE), {  unused (D.R.C.S.): 10 }
(X : 15; Y : 17; Long : 2; Haut : 1; Vis : true; NoR : true), {  pixel1:11  }
(X : 17; Y : 17; Long : 2; Haut : 1; Vis : true; NoR : true), {  pixel2:12  }
(X : 15; Y : 18; Long : 2; Haut : 1; Vis : true; NoR : true), {  pixel3: 13  }
(X : 17; Y : 18; Long : 2; Haut : 1; Vis : true; NoR : true), {  pixel4: 14  }
(X : 15; Y : 19; Long : 2; Haut : 1; Vis : true; NoR : true), {  pixel5: 15  }
(X : 17; Y : 19; Long : 2; Haut : 1; Vis : true; NoR : true), {  pixel6: 16  }
(X : 1; Y : 19; Long : 13; Haut : 1; Vis : true; NoR : true), {  graphik : 17  }
(X : 61; Y : 3+2; Long : 18; Haut : 2; Vis : true; NoR : true), {  AffVrai:18  }
{  le menu droit de la ligne 3 a 23  }
(X : 61; Y : 3; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 19  }
(X : 61; Y : 4; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 20  }
(X : 61; Y : 5; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 21  }
(X : 61; Y : 6; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 22  }
(X : 61; Y : 7; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 23  }
(X : 61; Y : 8; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 24  }
(X : 61; Y : 9; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 25  }
(X : 61; Y : 10; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 26  }
(X : 61; Y : 11; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 27  }
(X : 61; Y : 12; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 28  }
(X : 61; Y : 13; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 29  }
(X : 61; Y : 14; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 30  }
(X : 61; Y : 15; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 31  }
(X : 61; Y : 16; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 32  }
(X : 61; Y : 17; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 33  }
(X : 61; Y : 18; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 34  }
(X : 61; Y : 19; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 35  }
(X : 61; Y : 20; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 36  }
(X : 61; Y : 21; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 37  }
(X : 61; Y : 22; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 38  }
(X : 61; Y : 23; Long : 18; Haut : 1; Vis : true; NoR : true), {  msk : 39  }
{  ERROR FIELD  }
(X : 51; Y : 6; Long : 9; Haut : 1; Vis : true; NoR : true), {  ok : 40  }
(X : 36; Y : 6; Long : 9; Haut : 1; Vis : true; NoR : true), {  rep : 41  }
(X : 20; Y : 6; Long : 9; Haut : 1; Vis : true; NoR : true), {  aban : 42  }
(X : 0), {  indef : 43  }
{  DISK WIND  }
(X : 58; Y : 13; Long : 3; Haut : 1; Vis : true; NoR : true), {  ? : 44  }
(X : 58; Y : 1; Long : 3; Haut : 1; Vis : true; NoR : true), {  rrr : 45  }
(X : 58; Y : 2; Long : 3; Haut : 1; Vis : true; NoR : true), {  deb.: 46  }
(X : 58; Y : 4; Long : 3; Haut : 1; Vis : true; NoR : false), {  haut: 47  }
(X : 58; Y : 5; Long : 3; Haut : 1; Vis : true; NoR : false), {  3haut : 48 }
(X : 58; Y : 7; Long : 3; Haut : 1; Vis : true; NoR : true), {  mil.: 49  }
(X : 58; Y : 9; Long : 3; Haut : 1; Vis : true; NoR : false), {  3bas : 50  }
(X : 58; Y : 10; Long : 3; Haut : 1; Vis : true; NoR : false), {  bas : 51  }
(X : 58; Y : 12; Long : 3; Haut : 1; Vis : true; NoR : true), {  fin : 52  }
(X : 19; Y : 16; Long : 42; Haut : 1; Vis : true; NoR : true), {  rep : 53  }
(X : 19; Y : 18; Long : 42; Haut : 1; Vis : true; NoR : true), {  fich: 54  }
(X : 19; Y : 2; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 55  }
(X : 19; Y : 3; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 56  }
(X : 19; Y : 4; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 57  }
(X : 19; Y : 5; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 58  }
(X : 19; Y : 6; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 59  }
(X : 19; Y : 7; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 60  }
(X : 19; Y : 8; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 61  }
(X : 19; Y : 9; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 62  }
(X : 19; Y : 10; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 63  }
(X : 19; Y : 11; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 64  }
(X : 19; Y : 12; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 65  }
(X : 19; Y : 13; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 66  }
(X : 19; Y : 14; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 67  }
(X : 19; Y : 15; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 68  }
(X : 19; Y : 16; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 69  }
(X : 19; Y : 17; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 70  }
(X : 19; Y : 18; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 71  }
(X : 19; Y : 19; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 72  }
(X : 19; Y : 20; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 73  }
(X : 19; Y : 21; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 74  }
(X : 19; Y : 22; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 75  }
(X : 19; Y : 23; Long : 38; Haut : 1; Vis : true; NoR : true), {  r1 : 76  }
{  div  }
(X : 44; Y : 10; Long : 8; Haut : 1; Vis : true; NoR : true), {  infok : 77  }
{  charge  }
(X:22; Y : 18+2; Long : 17; Haut : 3; Vis : true; NoR : true), {  vdt : 78  }
(X:43; Y : 18+2; Long : 15; Haut : 3; Vis : true; NoR : true), {  dti : 79  }
(X:19; Y:23; Long:9; Haut:1; Vis:true; NoR : true), {  aban. : 80  }
{  sauve  }
(X : 31; Y : 18+2; Long : 20; Haut : 4; Vis : true; NoR : true), {  sauve: 81  }
(X : 19; Y : 23; Long : 9; Haut : 1; Vis : true; NoR : true), {  aban. : 82  }
{  parametrage  }
(X : 34; Y : 22; Long : 13; Haut : 1; Vis : true; NoR : true), {  init : 83  }
(X : 51; Y : 22; Long : 8; Haut : 1; Vis : true; NoR : true),  {  ok : 84  }
{  intro  }
(X : 21; Y : 5; Long : 38; Haut : 1; Vis : true; NoR : true), {  curstat : 85  }
(X : 21; Y : 6; Long : 38; Haut : 1; Vis : true; NoR : true), {  lnzero : 86  }
(X : 21; Y : 7; Long : 38; Haut : 1; Vis : true; NoR : true), {  vdecran: 87  }
{  develop  }
(X : 21; Y : 10; Long : 38; Haut : 1; Vis : true; NoR : true), {  mntl : 88  }
(X : 21; Y : 11; Long : 38; Haut : 1; Vis : true; NoR : true), {  mdaff : 89  }
(X : 20; Y : 1; Long : 40; Haut : 1; Vis : true; NoR : true), {  fond : 90  (intro) }
(X : 21; Y : 8; Long : 38; Haut : 1; Vis : true; NoR : true), {  force cur: 91 (intro) }
(X : 21; Y : 12; Long : 38; Haut : 1; Vis : true; NoR : true), {  Options : 92  }
{  conclu  }
(X : 21; Y : 14; Long : 38; Haut : 1; Vis : true; NoR : true), {  plcur : 93  }
(X : 25; Y : 17; Long : 8; Haut : 1; Vis : true; NoR : false), {  line : 94  }
(X : 35; Y : 17; Long : 10; Haut : 1; Vis : true; NoR : false), {  col : 95  }
(X : 48; Y : 17; Long : 7; Haut : 1; Vis : true; NoR : true), {  point : 96  }
(X : 21; Y : 18; Long : 38; Haut : 1; Vis : true; NoR : true), {  mode : 97  }
(X : 21; Y : 19; Long : 18; Haut : 1; Vis : true; NoR : false), {  trait : 98  }
(X : 21; Y : 20; Long : 18; Haut : 1; Vis : true; NoR : false), {  tail : 99  }
(X : 41; Y : 19; Long : 18; Haut : 1; Vis : true; NoR : true), {  inv : 100  }
(X : 41; Y : 20; Long : 18; Haut : 1; Vis : true; NoR : true), {  sta : 101  }
(X : 21; Y : 19-4; Long : 38; Haut : 1; Vis : true; NoR : true), {  cur : 102  }
(X : 21; Y : 22; Long : 9; Haut : 1; Vis : true; NoR : true), {  aban : 103  }
(X : 69; Y : 1; Long : 10; Haut : 1; Vis : true; NoR : true), {  Mntl drt: 104  }
(X : 21; Y : 2+1; Long : 38; Haut : 1; Vis : true; NoR : true), {  chain : 105  }
(X : 60-6; Y : 14; Long : 8; Haut : 1; Vis : true; NoR : true), {  oksoft : 106  }
(X : 66; Y : 19; Long : 8; Haut : 3; Vis : true; NoR : true),  {  trans : 107  }
(X : 21; Y : 3+1; Long : 38; Haut : 1; Vis : true; NoR : true), {  cds : 108  }
(X : 21; Y : 20-4; Long : 38; Haut : 1; Vis : true; NoR : true),  {  cds : 109  }
{ param/option }
(X : 18; Y : 23; Long : 9; Haut : 1; Vis : true; NoR : true),  {  aban : 110  }
(X : 54; Y : 23; Long : 8; Haut : 1; Vis : true; NoR : true),  {  ok : 111  }
(X : 17; Y : 12;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { Rep : 112 }
(X : 17; Y : 13;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { Grp : 113 }
(X : 17; Y : 14;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { Txt : 114 }
(X : 17; Y : 15;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { CSI : 115 }
(X : 17; Y : 16;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { OM  : 116 }
(X : 17; Y : 17;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { IGr : 117 }
(X : 17; Y : 18;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { ITx : 118 }
(X : 17; Y : 19;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { DC  : 119 }
(X : 17; Y : 20;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { FDl : 120 }
(X : 17; Y : 10;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { saute vide  : 121 }
(X : 21; Y : 16; Long : 38; Haut : 1; Vis : true; NoR : true),  {  plcur2 : 122 }
(X : 21; Y : 22; Long : 9; Haut : 1; Vis : true; NoR : true),   {  aban : 123 }
(X : 51; Y : 22; Long : 8; Haut : 1; Vis : true; NoR : true),   {  ok : 124  }
(X : 17; Y : 11;  Long : 46; Haut : 1; Vis : TRUE; NoR : TRUE), { saute cpl : 125 }
(X : 1; Y : 17; Long : 13; Haut : 1; Vis : true; NoR : true),   { DRCS : 126  }
(X:1; Y:1; Long:18; Haut:1; Vis:TRUE; NoR:TRUE),  { Jx DRCS   : 127 }
(X:1; Y:3; Long:18; Haut:1; Vis:TRUE; NoR:TRUE),  { Fond Raff : 128 }
(X:1; Y:5; Long:18; Haut:1; Vis:TRUE; NoR:TRUE),  { ? : 129 }
(X:1; Y:7; Long:18; Haut:1; Vis:TRUE; NoR:TRUE),  { ? : 130 }
(X:15; Y:21; Long:4; Haut:1; Vis:true; NoR:true),  { jeux G1 :131  }
{ Editeur DRCS }
(X:6; Y:23; Long:9; Haut:1; Vis:TRUE; NoR:TRUE),  { abandon: 132 }
(X:24; Y:23; Long:13; Haut:1; Vis:TRUE; NoR:TRUE), { init: 133 }
(X:49; Y:23; Long:6; Haut:1; Vis:TRUE; NoR:TRUE),  { test: 134 }
(X:66; Y:23; Long:8; Haut:1; Vis:TRUE; NoR:TRUE),  { ok: 135 }
(X:61; Y:23; Long:8; Haut:1; Vis:true; NoR:true),  { Annule : 136 }
(X:70; Y:23; Long:9; Haut:1; Vis:true; NoR:true),  { Restaure : 137  }
(X:17; Y:21; Long:46; Haut:1; Vis:TRUE; NoR:TRUE), { NoRC : 138 }
(X:19; Y:14; Long:42; Haut:1; Vis:true; NoR:true),  { ExtList : 139 }
(X:61; Y:3; Long:7; Haut:1; Vis:TRUE; NoR:TRUE),    { Affiche : 140 }
(X:69; Y:3; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),    { Fond : 141 }
(X:74; Y:3; Long:5; Haut:1; Vis:TRUE; NoR:TRUE),    { Vide : 142 }
{ Video EGA, controle des effets }
(X:1; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),    { Min. : 143 }
(X:6; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),    { Gra. : 144 }
(X:11; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { Inv. : 145 }
(X:16; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { DRCS : 146 }
(X:21; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { Coul : 147 }
(X:26; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { Max. : 148 }
(X:21; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { ? : 149 }
(X:26; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { ? : 150 }
(X:21; Y:26; Long:4; Haut:1; Vis:TRUE; NoR:TRUE),   { ? : 151 }
(X:31; Y:26; Long:9; Haut:1; Vis:TRUE; NoR:TRUE),   { ? : 152 }
(X:41; Y:26; Long:9; Haut:1; Vis:TRUE; NoR:TRUE)    { ? : 153 }
               );


Const FieldEga = 143;

const MaxFld = 50;
var
     Fld     : array[1..MaxFld] of Fld_map;

type StrChoix = string[18];
     StrMenu_ref = array[1..20] of StrChoix;

const XMouseStr = 1;
      YMouseStr = 24;
      MouseStr   = ' SOURIS ';
      NoMouseStr = '';

var Mouse : boolean; {  si la souris existe!  }
    ClavMouse : boolean; {  si la clavier est dedie a la souris  }
var SMouseX,SMouseY : word;
    SButton : word;
    MaxMouseL : Byte;
    ShowMouse_Flag : Boolean;

var  Key            : char;
     Funct          : boolean;
     CTRL           : byte;

var MouseX,MouseY : word;
    MouseL,MouseC : byte;
    ButtonL,ButtonR : boolean;

var  (*
     PXhaut,PYhaut,PXbas,PYbas : byte;
     *)
     CurX, CurY     : Byte;
     ExCurX, ExCurY : Byte;

     ResetCur : Boolean;    { TRUE=> force le replacement }

     WaitUSXY : Boolean;    { TRUE=> on ne peut envoyer le code }

     CurMntl : boolean; {  indique si le curseur est place sur le minitel  }

Type FixeField1Proc = Function( Var field1 : fields_map; Data : Pointer ) : Boolean;

Var
     InterProc : Procedure;

     FixeField1 : FixeField1Proc;
     DataField1 : Pointer;


type intertype = record
                  SelectField   : byte;    {  1  }
                  BtnGauche     : boolean; {  1  }
                  FieldEcran    : byte;    {  1  }
                  ChoixField    : boolean; {  1  }
                  RepeatOn      : boolean; {  1  }
                  MouseCompteur : word;    {  2  }
                  ConstantOut   : boolean; {  1  }
                  IntNormal     : boolean; {  1  }
                end;
     pintertype = ^intertype;

var inter : intertype; {  reserve pour INTERACTION  }

procedure IntMouse(var reg : registers);
procedure WriteMouseStr;
procedure MouseStatus;
procedure InitFld;
procedure EmpileFld;
procedure DepileFld;
procedure ChsFld(NumField :byte);
procedure FieldAspect( NumField, Att : byte);
procedure FieldOff;    { A utiliser si l'on modifie le contenu d'un champ }
function Complete ( valeur, long : byte; caract : char) : string;
procedure CurSitu;

procedure ViewKey;

function Interaction : boolean;
procedure OpenInterCon;
procedure CloseInterCon;
procedure TheBeep;
procedure NoManLand;
procedure NoFieldLand;
function  WindError(StrError,StrMsg1,StrMsg2 : string; Gadget : byte) : byte;
Function  AbortRequest : Boolean;
Function  WaitOutEmpty : Boolean;
procedure MakeTrait(pos : byte; HowMany : shortint; pas : byte);
procedure ShowTitle(texte : string);
procedure NewMenu(titre : string; var point; NbreChoix : byte);
procedure EndNewMenu;
procedure MenuDroit;
procedure BasMenuDroit;
procedure MenuGauche;
procedure MenuHaut;
Procedure MenuBas;

Procedure ShowCarRien;
Procedure RAffSmallMenu;


(*
procedure ShowGraphik(gra: byte);
*)
function InputString(var texte : string; var c_pos : word; max,lg_chp,col,ligne : byte) : boolean;


Var  MinConnected : Boolean;

Function GetC18 : Longint;
Procedure InstallC18;

Function WaitInStr( Texte : String; TiNoCode, TiMax : Word;
                    Var Res : String ) : Boolean;

Const SPEED_NIL = $FF;
(*
      Speed75   = 0;
      Speed300  = 1;
      Speed1200 = 2;
      Speed4800 = 3;
      Speed9600 = 4;
*)
      LastSpeed : Byte = SPEED_NIL; { la vitesse de dpart du minitel! }

Type SpeedRec = Record
       BD      : Word;
       CSpeed  : Char;
      End;

Const NbSpeed = 5;

      TabSpeed : Array[0..NbSpeed-1] Of SpeedRec = (
       ( BD:BAUD75;   CSpeed:Char(64+9)  ),
       ( BD:BAUD300;  CSpeed:Char(64+18) ),
       ( BD:BAUD1200; CSpeed:Char(64+36) ),
       ( BD:BAUD4800; CSpeed:Char(64+54) ),
       ( BD:BAUD9600; CSpeed:Char(64+63) )
       );


Function MinDetect( WantSpeed : Byte; Slow, AutoSeek : Boolean ) : Boolean;
Function MinStatusTerm( Var St : Byte ) : Boolean;
Function  MinOnLine : Boolean;
Procedure MinRestoreSpeed;

Const Deconnect = MPRO1+#$67+      { Deconnexion }
                  MPRO1+#$57;      { libration ligne }

      Connect1200  = MPRO1+#$53+      { Prise de ligne }
                     MPRO1+#$6F+      { Retournement }
                     MPRO1+#$68;      { Connexion }

      MPROReset = MPRO1+#$7F;

      Modem_Off_Ecran   = MPRO3+MOFF+MREcran+MEModem;
      Modem_On_Ecran    = MPRO3+MON+MREcran+MEModem;

      Modem_Off_Prise   = MPRO3+MOFF+MRPrise+MEModem;
      Modem_On_Prise    = MPRO3+MON+MRPrise+MEModem;

      Prise_Off_Modem   = MPRO3+MOFF+MRModem+MEPrise;
      Prise_On_Modem    = MPRO3+MON+MRModem+MEPrise;

      Prise_Off_Ecran   = MPRO3+MOFF+MREcran+MEPrise;
      Prise_On_Ecran    = MPRO3+MON+MREcran+MEPrise;

      Clavier_Off_Prise = MPRO3+MOFF+MRPrise+MEClavier;
      Clavier_On_Prise  = MPRO3+MON+MRPrise+MEClavier;

      Clavier_Off_Ecran = MPRO3+MOFF+MREcran+MEClavier;
      Clavier_On_Ecran  = MPRO3+MON+MREcran+MEClavier;

      Clavier_Off_Modem = MPRO3+MOFF+MRModem+MEClavier;
      Clavier_On_Modem  = MPRO3+MON+MRModem+MEClavier;

Procedure MinInitAffichage;
Procedure MinInitEmulation;
Procedure MinReset;
Procedure DetectTpMini;
Procedure KeepMinitel;

var NumField : integer;

function CompoField : boolean;

implementation { ***************************************** }

(*
Const ShowIsRien : Boolean = FALSE;

Var PYSave : Byte;

Procedure CompoOff;
Begin
 Exit;
 PYSave := PYhaut;
 PYhaut := ScreenHigh;
 ShowCarRien;
End;

Procedure CompoON;
Begin
 Exit;
 PYHaut := PYSave;
End;
*)

{ Cette procedure est necessaire, car CRT limite  25 lignes.... }

Procedure GotoXY( X, Y : Byte );
Begin
 CurXY(X-1,Y-1);
End;

const TabBit : array [0..3] of byte = (32,223,220,219);

var
    NbreFld : byte;


Procedure ViewKey;
var reg : registers;
Begin
 InterProc;
 if keypressed then
   begin
     reg.ax := $0200;
     intr($16,reg);
     CTRL := reg.al;
     key := ReadKey;
     if key=#0 then
       begin
         key := ReadKey;
         Funct := true;
       end
     else Funct := false;
   end
 else Key := #0;
End;

procedure GetKey;
begin
 repeat
  ViewKey;
 until Key<>#0;
end;


Var ExInt1C  : Pointer;
    SaveExit : Pointer;
    C18      : Longint;


{$IFOPT R+ } {$DEFINE RON } {$R-} {$ENDIF }
{$IFOPT S+ } {$DEFINE SON } {$S-} {$ENDIF }

Procedure NewInt1C; Assembler;
Asm
 PUSH AX
 PUSH DS

 MOV  AX, SEG @DATA
 MOV  DS, AX

 ADD  [WORD PTR C18], 1
 ADC  [WORD PTR C18+2], 0

 PUSHF
 CALL [ExInt1C]

 POP  DS
 POP  AX
 IRET
End;

{$IFDEF SON } {$S+ } {$UNDEF SON } {$ENDIF }
{$IFDEF RON } {$R+ } {$UNDEF RON } {$ENDIF }


Function GetC18 : Longint; Assembler;
Asm
    CLI
    MOV  AX, [WORD PTR C18]
    MOV  DX, [WORD PTR C18+2]
    STI
End;



Procedure DisposeC18; Far;
Begin
 ExitProc := SaveExit;
 SetIntVec($1C,ExInt1C);
End;


Procedure InstallC18;
Begin
  C18 := 1;   { et non 0 }

  GetIntVec($1C,ExInt1C);
  SetIntVec($1C,@NewInt1C);

  SaveExit := ExitProc;
  ExitProc := @DisposeC18;
End;




{ ****************** MOUSE **************** }

Var ExProc : VideoResetProc;
    MouseReady : Boolean;

Procedure ResetMouse; Far;
Var Reg : Registers;
    SaveX : Word;
    SaveY : Word;
Begin
 Reg.AX := $0003;
 Intr($33,Reg);
 SaveX := Reg.CX;
 SaveY := Reg.DX;

 Reg.AX := $0000;
 Intr($33,Reg);
 If Reg.AX=$FFFF Then
  Begin
   reg.AX := $0008;
   reg.CX := 0;
   reg.DX := 199+8*3;
   Intr($33,Reg);

   Reg.AX := $0004;
   Reg.CX := SaveX;
   Reg.DX := SaveY;
   Intr($33,Reg);
  End;
 CallVideoResetProc(ExProc);
End;

procedure IntMouse(var reg : registers);
Var Init : Boolean;
begin
{  GotoXY(1,25);
  write(MemAvail,'*'); }
  VideoSynchro(GetC18);
  if Mouse then
   Begin
    Init := (Reg.AX=$0000);
    If (Init) Then Byte(ShowMouse_Flag) := 255;
    intr($33,reg);
    If (Init) And (Reg.AX=$FFFF) And VideoEGA Then
     Begin { 25+3 lignes }

      reg.AX := $0008;
      reg.CX := 0;
      reg.DX := 199+8*3;
      Intr($33,Reg);
      MaxMouseL := 25+3;

      If Not(MouseReady) Then
       Begin
        ExProc.Ptr := VideoReset.Ptr;
        VideoReset.Proc := ResetMouse;
        MouseReady := TRUE;
       End;

      Reg.AX := $FFFF;
     End
    Else MaxMouseL := 25;
   End
  else
    begin
      case reg.AX of
        0 : begin {  RESET  }
              Byte(ShowMouse_Flag) := 255;
              SMouseX := 320;
              SMouseY := 100;
              SButton := 0;
              reg.AX := 65535;
              If VideoEGA Then MaxMouseL := 25+3
              Else MaxMouseL := 25;
            end;
        3 : begin {  sit souris  }
              reg.CX := SMouseX;
              reg.DX := SMouseY;
              reg.BX := SButton;
            end;
        4 : begin
              if reg.CX>639 then reg.CX := 639;
              If VideoEGA Then
               Begin
                If reg.DX>199+8*3 Then reg.DX := 199+8*3;
               End
              Else if reg.DX>199 then reg.DX := 199;
              SMouseX := reg.CX;
              SMouseY := reg.DX;
            end;
      end;
    end;
end;


Procedure ShowMouse(  Affiche : Boolean );
Var Reg : Registers;
Begin
 If Video640 And ( (Byte(ShowMouse_Flag)=255) Or (Affiche<>ShowMouse_Flag) ) Then
  Begin
   ShowMouse_Flag := Affiche;
  End;
End;


procedure GestNoMouse;
type Tab_map = record
                 X,Y : shortint;
               end;
const Tab : array[71..81] of Tab_map = (
       (X:-1; Y:-1 ), {  71 : Home  }
       (X:0 ; Y:-1 ), {  72 : vers Haut  }
       (X:+1; Y:-1 ), {  73 : PgUp  }
       (X:0 ; Y:0  ), {  rien  }
       (X:-1; Y:0  ), {  75 : vers gauche  }
       (X:0 ; Y:0  ), {  rien  }
       (X:+1; Y:0  ), {  77 : vers droite  }
       (X:0 ; Y:0  ), {  rien  }
       (X:-1; Y:+1 ), {  79 : end  }
       (X:0 ; Y:+1 ), {  80 : vers bas  }
       (X:+1; Y:+1 )  {  81 : PgDn  }
           );
var X,Y : ShortInt;
begin
  if Funct then
   begin
    if byte(Key) in [71,72,73,75,77,79,80,81,115,116] then
      begin
        X := SMouseX div 8;
        Y := SMouseY div 8;
        if Key=#115 then X := X-3
        else
          if Key=#116 then X := X+3
            else
              begin
                X := X+Tab[byte(Key)].X;
                Y := Y+Tab[byte(Key)].Y;
              end;
        if X>79 then X := 79
        else
          if X<0 then X := 0;
        if Y>=MaxMouseL then Y := MaxMouseL-1
        else
          if Y<0 then Y := 0;
        SMouseX := X*8;
        SMouseY := Y*8;
        Key := #0;
      end;
   end
  else
    begin
      if Key='+' then SButton := 1
      else
        if Key='-' then SButton := 2
        else exit;
      Key:=#0;
    end;
end;

procedure WriteMouseStr;
begin
  if ClavMouse then WrtScr(MouseStr,XMouseStr,YMouseStr,CMouseStr)
  else WrtScr(NoMouseStr,XMouseStr,YMouseStr,CSep);
end;

procedure MouseStatus;
var reg : registers;
begin
  ViewKey;
  if not(Mouse) then
    begin
      SButton := 0;
      if Key<>#0 then
        if not(Funct) and (Key=#24) then
          begin
            ClavMouse := not(ClavMouse);
            Key:=#0;
            WriteMouseStr;
          end
        else if ClavMouse then GestNoMouse;
    end;
  reg.AX := 3;
  IntMouse(reg);
  ButtonL := (reg.BX and 1) <> 0;
  ButtonR := (reg.BX and 2) <> 0;
  MouseX  := reg.CX;
  MouseY  := reg.DX;
  MouseL  := MouseY shr 3;
  MouseC  := MouseX shr 3;
end;

procedure DelSaveFld(fielde : byte);
begin
  if Fld[fielde].save then
    begin
      Fld[fielde].save := false;
      FreeMem(Fld[fielde].point,Fld[fielde].long);
    end;
end;

procedure DelAllSaveFld;
var index : byte;
begin
  for index := 1 to NbreFld do DelSaveFld(index);
end;

procedure ResetFld(fielde : byte);
type line_map = record
                  car : byte;
                  att  : byte;
                end;
var i,jindex : byte;
    NumField    : byte;
    line : array[1..80] of line_map;
    line2 : array[1..80] of line_map;
    Zn : Zn_Rec;
begin
  if Fld[fielde].save then
    begin
      NumField := Fld[fielde].field;
      Zn.X := field[NumField].X;
      Zn.Y := field[NumField].Y;
      Zn.Lg := field[NumField].long;
      Zn.Ht := field[NumField].haut;
      for i:= Zn.Y to Zn.Y+Zn.Ht-1 do
        begin
          FromScr(@line,Zn.X,i,Zn.Lg);
          move(mem[Fld[fielde].seg:Fld[fielde].ofs+(i-Zn.Y)*Zn.Lg*2],
               line2,Zn.Lg*2);
          If VideoEGA Then
           for jindex:=1 to Zn.Lg do
            line[jindex].att := line2[jindex].att Or (line[jindex].att And (8+128))
          Else
           for jindex:=1 to Zn.Lg do
            line[jindex].att := line2[jindex].att;
          ToScr(@line,Zn.X,i,Zn.Lg);
       end;
     Fld[fielde].save := false;
     FreeMem(Fld[fielde].point,Fld[fielde].long);
   end;
end;

procedure SaveFld(fielde : byte);
var long     : word;
    line     : byte;
    NumField : byte;
    Zn : Zn_Rec;
begin
  if not(Fld[fielde].save) then
    begin
      Fld[fielde].save := true;
      NumField := Fld[fielde].field;
      long := (field[NumField].long*field[NumField].haut) shl 1;
      GetMem(Fld[fielde].point,long);
      Fld[fielde].long := long;
      Zn.X := field[NumField].X;
      Zn.Y := field[NumField].Y;
      Zn.Lg := field[NumField].long;
      Zn.Ht := field[NumField].haut;
      for line := Zn.Y to Zn.Y+Zn.Ht-1 do
        FromScr(ptr(Fld[fielde].seg,Fld[fielde].ofs+
                    ((line-Zn.Y)*Zn.lg)*2),
                Zn.X,Line,Zn.Lg );
    end;
end;

{ ******************* PILE FLD ****************** }

type fldpile_map = record
                     NbreFld : byte;
                     long    : word;
                     case word of
                       FALSE : (point : pointer);
                       TRUE  : (Ofs,Seg : word);
                   end;
const MaxFldPile   = 20; {  20 niveaux de pile pour les champs  }
var   FldPile : array[1..MaxFldPile] of fldpile_map;
      LongFldPile : byte;

procedure InitFld;
begin
  NbreFld := 0;
  inter.FieldEcran := 0;
  inter.RepeatOn := false;
  inter.ConstantOut := false;
  inter.IntNormal := true;
end;

procedure ChsFld(NumField :byte);
begin
  if NbreFld<MaxFld then
    begin
      Inc(NbreFld);
      Fld[NbreFld].field := NumField;
      Fld[NbreFld].select := false;
      Fld[NbreFld].save := false;
    end
end;

procedure EmpileFld;
begin
  if LongFldPile<MaxFldPile then
    begin
      Inc(LongFldPile);
      FldPile[LongFldPile].NbreFld := NbreFld;
      FldPile[LongFldPile].long := sizeof(intertype)+NbreFld*SizeOf(Fld_map);
      GetMem(FldPile[LongFldPile].point,FldPile[LongFldPile].long);
      move(inter,FldPile[LongFldPile].point^,sizeof(intertype));
      move(Fld[1],mem[FldPile[LongFldPile].seg:
           FldPile[LongFldPile].ofs+sizeof(intertype)],
           NbreFld*SizeOf(Fld_map));
      InitFld;
    end
{ $IFDEF DEBUG  }
  else
    begin
      Sound(4000);
      GotoXY(21,1);
      write('Pile FIELD pleine!.');
      nosound;
    end;
{ $ENDIF  }
end;

procedure DepileFld;
begin
  if LongFldPile>0 then
    begin
      DelAllSaveFld; {  on vide la memoire avant de quitter !  }
      NbreFld := FldPile[LongFldPile].NbreFld;
      move(FldPile[LongFldPile].point^,inter,sizeof(intertype));
      move(mem[FldPile[LongFldPile].seg:
               FldPile[LongFldPile].ofs+sizeof(intertype)],
           Fld[1],NbreFld*SizeOf(Fld_map));
      FreeMem(FldPile[LongFldPile].point,FldPile[LongFldPile].long);
      Dec(LongFldPile);
    end
{ $IFDEF DEBUG  }
  else
    begin
      sound(4000);
      GotoXY(21,1);
      write('pile FIELD vide!.');
      nosound;
    end;
{ $ENDIF  }
end;

{ ************************* OTHER ************************** }


Const XMat = 1;
      YMat = 3;

Procedure ShowMat( Var Mat : MinMatrice; x, y, Attr : Byte );
Var i, j : Byte;
    h, l : Byte;
    hh, ll : Boolean;
    c    : Char;
    s    : String[8];
Begin
 s[0] := #8;
 For i := 0 To 4 Do
  Begin
   h := Mat[i*2];
   l := Mat[i*2+1];
   For j := 7 Downto 0 Do
    Begin
     hh := (h And (1 Shl j))<>0;
     ll := (l And (1 Shl j))<>0;
     If hh Then
      If ll Then c := '' Else c := ''
     Else
      If ll Then c := '' Else c := ' ';
     s[8-j] := c;
    End;
   WrtScr(s,x,y+i,Attr);
  End;
End;


Procedure MatGraphik(gra: byte; Var d : MinMatrice );
Var Mat : MinMatrice;
    x   : Byte;
    i   : Byte;
Begin
 x := ((gra Shr 1) And 1)*15+(gra And 1)*240;
 For i := 0 To 2 Do Mat[i] := x;

 x := ((gra Shr 3) And 1)*15+((gra Shr 2) And 1)*240;

 For i := 3 To 6 Do Mat[i] := x;

 x := ((gra Shr 5) And 1)*15+((gra Shr 4) And 1)*240;

 For i := 7 To 9 Do Mat[i] := x;

 d := Mat;
End;


Function GWhat( Car : Char; Attr : Word;
                Var RamDRCS : VDispRamDRCS;
                Var mm : MinMatrice ) : String;
Var s : String[1];
    d : String[3];
    c : Byte;
    g : Byte;
Begin
 If (Car=#0) Or (Car=Char(Complement)) Then
  Begin
   mm := JeuG0[0];
   GWhat := '';
  End
 Else
  If Attr And Graphik<>0 Then
   Begin
    If  (Attr And DRCS=0) Then
     Begin
      MatGraphik( InvGraphCorrector(Byte(car)), mm );
      GWhat := 'G1 '+Hexa(Byte(car));
     End
    Else
     Begin
      If (Car=#32) Or (Car=#127) Then
       Begin
        MatGraphik( InvGraphCorrector(Byte(car)), mm );
       End
      Else mm := RamDRCS[1,Byte(Car)-Byte('!')];
      GWhat := 'G''1 '+Hexa(Byte(car));
     End;
   End
  Else
   Begin
    s := Car;
    IbmVdt(s,d);
    If d='' Then d := ' ';
    If d[1]>=#32 Then
     Begin
      If Attr And DRCS=0 Then
       Begin
        mm := JeuG0[Byte(d[1])-32];
        GWhat := 'G0 '+Hexa(Byte(d[1]));
       End
      Else
       Begin
        If (Car=#32) Or (Car=#127) Then mm := JeuG0[Byte(d[1])-32]
        Else mm := RamDRCS[0,Byte(d[1])-Byte('!')];
        GWhat := 'G''0 '+Hexa(Byte(d[1]));
       End;
     End
    Else
     Begin
      c := InRang(Accent,5,Byte(d[2]));
      If c>0 Then
       Begin
        g := InRang(Voyelle,5,Byte(d[3]));
        If g>0 Then mm := JeuG2B[((c-1)*5)+(g-1)]
        Else
         If d[3]='c' Then mm := JeuG2B[C_CEDILLE]
         Else mm := JeuG0[Byte(d[3])-32];
         (*
          If d[3]='C' Then mm := JeuG0[Byte('C')-32]
          Else mm := JeuG0[0];
         *)
        GWhat := 'G2 '+Hexa(Byte(d[2]))+' '+Hexa(Byte(d[3]));
       End
      Else
       Begin
        c := InRang(SS2,LgG2,Byte(d[2]));
        If c>0 Then mm := JeuG2[c-1] Else mm := JeuG0[0];
        GWhat := 'G2 '+Hexa(Byte(d[2]));
       End;
     End;
   End;
End;


Procedure ShowAttr( Attr : Word );
Var s : String[9];
Begin
 WrtScr(TxtCoul[Attr And Trait],10,3,CNet);
 WrtScr(TxtCoul[(Attr And Fond) Shr 3],10,4,CNet);
 WrtScr(TxtTail[(Attr And Taille) Shr 6],10,5,CNet);
 If Attr And Inverse<>0 Then s := 'Inve' Else s := '    ';
 If Attr And Stable=0 Then s := s+' Clig' Else s := s+'     ';
(* If Attr And (Inverse+Stable)=Inverse Then s[5] := '/'; *)
 WrtScr(s,10,6,CNet);
 If Attr And Souligne<>0 Then
  If Attr And Graphik=0 Then s := 'Soul' Else s := 'Disj'
 Else s := '    ';
 If Attr And Mask<>0 Then s := s+' Masq' Else s := s+'     ';
(* If Attr And (Souligne+Mask)=(Souligne+Mask) Then s[5] := '/'; *)
 WrtScr(s,10,7,CNet);
End;


Procedure ShowAttrRien;
Var i : Byte;
Begin
 For i := 3 To 7 Do WrtScr('         ',10,i,CNet);
End;


Procedure ShowCar( Car : Char; Attr : Word );
Var s : String[20];
    m : MinMatrice;
    i : Byte;
Begin
(*
 If Not(ShowIsRien) Then Exit;
 ShowIsRien := FALSE;
*)
 s := GWhat( Car, Attr, cM^.DRCS, m );
 If (Car=#0) Then s := 'VIDE'
 Else
  If Car=Char(Complement) Then s := 'COMPLEM.'
  Else
   If (Car=#$20) And (Attr And Delim<>0) Then s := s+' *';

 While Length(s)<8 Do s := s+' ';
 WrtScr(s,XMat,YMat-2,CNet);

 ShowMat(m,XMat,YMat,CPixel);

 If Car=#0 Then ShowAttrRien
 Else ShowAttr(Attr);
End;


Procedure ShowCarRien;
Var Buf : String;
    i   : Byte;
Begin
(*
 If ShowIsRien Then Exit;
 ShowIsRien := TRUE;
*)
(*
 WrtScr('         ',10,1,CDisp); {  on vire les coords apparente  }
 WrtScr('        ',XMat,YMat-2,CNet);
 ShowMat(JeuG0[0],XMat,YMat,CPixel);
 ShowAttrRien;
*)
 FieldOff;

 WrtScr('',9,0,CSep);
 For i := 1 To 3 Do
  Begin
   Case i Of
    1 : If Cfg.GlobalRAff Then Buf := 'Rafrach. Global' Else Buf := 'Rafrach. Local';
    2 : If cM^.IntroRAff Then Buf := 'Intro. Associe' Else Buf := 'Intro. Ignore';
    3 : Buf := ''; (* Buf := 'Jeux D.R.C.S'; *)
    4 : Buf := '';
   End;

   WrtScr(CentreString(Buf,18,32),1,(i*2)-1,CDisp);
   WrtScr('Ĵ',0,i*2,CSep);
  End;

 WrtScr(CentreString('',18,32),1,7,CDisp);
End;


Procedure ShowCarFond;
Var i : Byte;
Begin
 FieldOff;

 WrtScr('L.   C.  ',10,1,CMiNet);

 WrtScr('',9,0,CSep);
 WrtScr('',9,1,CSep);
 WrtScr('Ĵ',1,2,CSep);

 For i := 1 To 3 Do
  Begin
   WrtScr('',0,i*2,CSep);
   WrtScr('',19,i*2,CSep);
  End;

 For i := 3 To 7 Do WrtScr('',9,i,CSep);
End;


Procedure RAffSmallMenu;
Begin
 if (CurY>=ScreenHigh) then
  Begin { curseur hors compo }
   ShowCarRien;
  End;
End;


(*
procedure Car4Bits(var val1, val2: byte);
var rappel : byte;
begin
  rappel:= val1;
  val1:=TabBit[(rappel and 1) or ((rappel and 4) shr 1)];
  val2:=TabBit[((rappel and 2) shr 1) or ((rappel and 8) shr 2)];
end;

procedure ShowGraphik(gra: byte);
var index : byte;
    tj : array[0..1] of byte;
begin
  tj[0]:=(gra and 3)*4;
  Car4Bits(tj[0], tj[1]);
  for index:=0 to 1 do
    if tj[index]<>32 then WrtDt(tj[index],Xgraphik+index,Ygraphik,CPixelsup)
       else WrtDt(220,Xgraphik+index,Ygraphik,CPixelsup and 248);
  tj[0]:=gra div 4;
  Car4Bits(tj[0],tj[1]);
  for index:=0 to 1 do WrtDt(tj[index],Xgraphik+index,Ygraphik+1,CPixel);
end;
*)

{ ****************** curseur *************** }
function Complete ( valeur, long : byte; caract : char) : string;
var texte : string;
begin
  str ( valeur:long,texte);
  ChangeData(texte,32,byte(caract));
  Complete := texte;
end;

{ ******************** INTERACTION ********************** }

procedure FldAspect( fielde,Att : byte);
var NumField : byte;
    Zn : Zn_Rec;
begin
  NumField := Fld[fielde].field;
  if field[NumField].Vis then
    begin
      Zn.X := field[NumField].X;
      Zn.Y := field[NumField].Y;
      Zn.Lg := field[NumField].long;
      Zn.Ht := field[NumField].haut;
      AspZn(Zn,Att);
    end;
end;

procedure FieldAspect( NumField, Att : byte);
var Zn : Zn_Rec;
begin
 FieldOff;

 Zn.X := field[NumField].X;
 Zn.Y := field[NumField].Y;
 Zn.Lg := field[NumField].long;
 Zn.Ht := field[NumField].haut;
 AspZn(Zn,Att);
end;

procedure FieldOff;
begin
  if inter.FieldEcran>0 then
    if Field[Fld[inter.FieldEcran].field].vis then
      if not(Fld[inter.FieldEcran].select) then
        ResetFld(inter.FieldEcran) {  ok  }
      else
        FldAspect(inter.FieldEcran,SurEvidenceField); {  champs particulier  }
  inter.FieldEcran := 0;
  inter.RepeatOn := false;
end;

function InField (num_field : byte) : boolean;
begin
 InField := ( (MouseC>=field[num_field].X) and
              (MouseC<field[num_field].X+field[num_field].long) and
              (MouseL>=field[num_field].Y) and
              (MouseL<field[num_field].Y+field[num_field].haut) );
end;

Function TakeAttRam( x, y : Byte ) : Word;
Begin
 With cM^.Ram[y,x] Do
  If Car=#0 then TakeAttRam := BasePanel
  Else TakeAttRam := Att;
End;

procedure CurSitu;
begin
  if CurY>=ScreenHigh then
    begin {  le curseur est hors de la compo  }

      If Not(WaitUSXY) And ResetCur Then
       Begin

        Mntl.Write(char(20));         {  on eteind curseur du minitel  }

        ResetCur := FALSE;
        ShowMouse(TRUE);
       End;

      if (ExCurY<ScreenHigh) Then
        begin {  c une nouvelle information  }
          If PYhaut<ScreenHigh Then ShowCarRien;
          ExCurY := ScreenHigh;
          ExCurX := ScreenLong;
          If WaitUSXY Then ResetCur := TRUE
          Else
           Begin
            Mntl.Write(char(20));         {  on eteind curseur du minitel  }
            ResetCur := FALSE;
            ShowMouse(TRUE);
           End;
        end;
       {  sinon on considere que les operations ci-dessus sont
          deja effective  }
    end
  else
    begin {  curseur acceptable  }

      If Not(WaitUSXY) And ResetCur Then
       Begin
        Mntl.Write(char(31)+char(64+CurY)+char(65+CurX)+#17);
        ResetCur := FALSE;
        ShowMouse(FALSE);
       End;

      if (ExCurY>=ScreenHigh) then
        begin {  la situation change grandement  }
          ShowCarFond;

          If WaitUSXY Then ResetCur := TRUE
          Else
           Begin
            Mntl.Write(#17);
            ShowMouse(FALSE);
           End;
        end;

      if (ExCurY<>CurY) or (ExCurX<>CurX) Or ResetCur then
        begin
          WrtScr(Complete(CurY,2,'0'),10+2,1,CNet);
          WrtScr(Complete(CurX+1,2,'0'),10+7,1,CNet);
          ExCurX := CurX;
          ExCurY := CurY;
          If WaitUSXY Then ResetCur := TRUE
          Else
           Begin
            if (Mntl.TransmitCount=0) then
              begin
                Mntl.Write(char(31)+char(64+CurY)+char(65+CurX));
                ResetCur := FALSE;
                CurMntl := true;
              end
            else CurMntl := false;
           End;

          With cM^.Ram[CurY,CurX] Do ShowCar( Car, Att );

        end
      else
        if (not(CurMntl) And Not(WaitUSXY) and (Mntl.TransmitCount=0)) then
          begin
            CurMntl := true;
            Mntl.Write(char(31)+char(64+CurY)+char(65+CurX));
            ResetCur := FALSE;
          end;
    end;
end;

function Interaction : boolean;
var on_champ       : boolean;
    SecondCompteur : word;
    Act_level      : byte;
    field1         : fields_map;
begin
  if inter.IntNormal then
    if not(inter.RepeatOn) then
      begin
        inter.ChoixField := false;
        FieldOff;
        inter.MouseCompteur := 0;
      end
    else
      begin
        inter.RepeatOn := false;
        SecondCompteur := 0;
      end
  else
    inter.IntNormal := true;
  repeat
    MouseStatus;
    GotoXY(MouseC+1,MouseL+1);

    InterProc;

    if inter.ChoixField then
      begin {  une selection est en cours  }
        if key<>#0 then begin
                          Interaction := true;
                          exit;
                        end;
        if not(field[Fld[inter.FieldEcran].field].NoR) and (inter.MouseCompteur>=MaxMouseCompteur)
          then
            begin
              if SecondCompteur>=StepMouseDelay then
                begin
                  if InField(Fld[inter.FieldEcran].field) then
                    begin
                      Interaction := true;
                      inter.SelectField := Fld[inter.FieldEcran].field;
                      FldAspect(inter.FieldEcran,SurEvidenceField);
                      inter.RepeatOn := true;
                      exit; { *** sortie *** }
                    end;
                end
              else
                begin
                  Inc(SecondCompteur);
                  delay(10);
                end;
              if (not(ButtonL) and not(ButtonR)) then
                begin {  abandon  }
                  FieldOff;
                  inter.ChoixField := false;
                end;
            end
          else
            begin
              if not(field[Fld[inter.FieldEcran].field].NoR) then
                begin
                  Inc(inter.MouseCompteur);
                  delay(10);
                  SecondCompteur := StepMouseDelay; {  normal  }
                end;
        if (not(ButtonL) and not(ButtonR)) then
          begin {  bouton relache  }
            If InField(Fld[inter.FieldEcran].field) then
              begin {  au but!  }
                Interaction := true;
                inter.SelectField := Fld[inter.FieldEcran].field;
                FldAspect(inter.FieldEcran,SurEvidenceField);
                exit; { *** sortie *** }
              end
            else
              begin {  a cote...  }
                FieldOff;
                inter.ChoixField := false;
              end;
          end;
            end;
      end
    else
      begin {  pas de selection en cours  }
        if (MouseC>19+PXhaut) and (MouseC<21+PXbas) and
           (MouseL>=PYhaut) and (MouseL<=PYbas) then
          begin {  dans la page de compo  }
            CurX := MouseC-20;
            CurY := MouseL;
            CurSitu;
            FieldOff;
            Interaction := false;
            exit;
          end;
        {  hors de la page de compo  }
        CurY := ScreenHigh; {  ligne irrecevable  }
        CurSitu;
        if key<>#0 then
          begin
            if inter.FieldEcran<>0 then
              inter.SelectField := Fld[inter.FieldEcran].field
            else inter.SelectField := 0;
            Interaction := true;
            exit;
          end;
        Act_level := 1;
        on_champ := false;
        while not(on_champ) and (Act_level<=NbreFld) do
         Begin
          If Fld[act_level].field=1 Then
           Begin
            If FixeField1( field1, DataField1 ) Then
             Begin
              on_champ := TRUE;
             End
            Else Inc(Act_level);
           End
          Else
           if InField(Fld[act_level].field) then on_champ := true
           else Inc(Act_level);
         End;

        if on_champ then
          begin {  souris dans un champ  }
            if (Act_level<>inter.FieldEcran) Or
               ((Fld[Act_level].field=1) And Not(EgalMem(field[1],field1,SizeOf(field1))) ) then
              begin
                FieldOff;

                If Fld[Act_level].field=1 Then field[1] := field1;

                SaveFld(Act_level);
                if Fld[Act_level].select then
                  FldAspect(Act_level,PassEvidenceField)
                else
                  FldAspect(Act_level,EvidenceField);
                inter.FieldEcran := Act_level;
              end;
            if (ButtonL) or (ButtonR) then
              begin
                inter.ChoixField := true;
                inter.BtnGauche := ButtonL;
                FldAspect(inter.FieldEcran,FieldTouch);
                inter.MouseCompteur := 0;
              end;
          end
        else FieldOff; {  souris dans aucun champ  }
      end;
  until inter.ConstantOut;
  inter.IntNormal := false;
  Interaction := false;
end;



procedure OpenInterCon;
begin
  InitFld;
  LongFldPile := 0;
end;

procedure CloseInterCon;
begin
  while(LongFldPile>0) do DepileFld;
  DelAllSaveFld; {  vide dernier niveau  }
end;

procedure TheBeep;
begin
 Beep;
 (*
  sound(1500);
  delay(50);
  NoSound;
 *)
end;

{
procedure NoManLand;
begin
  if (key<>#0) then
    begin
      gotoXY(21,1);
      write('K:',byte(key),' F:',funct,' C:',CTRL,'.');
    end;
end;

procedure NoFieldLand;
begin
  gotoXY(21,1);
  write('SF:',SelectField,' FE:',FieldEcran);
  write(' K:',byte(key),' F:',funct,' C:',CTRL,'.');
end;
 }
procedure NoManLand;
begin
  TheBeep;
end;

procedure NoFieldLand;
begin
  TheBeep;
end;

function WindError(StrError,StrMsg1,StrMsg2 : string; Gadget : byte) : byte;
var PY        : byte; {  sauvegarde  }
    Result    : byte;
    EndBoucle : boolean;
const x = 18;
      y = 0;
      Zn : Zn_Rec = ( x:18; y:0; lg:44; ht:8 );
      Zn2: Zn_Rec = ( x:18; y:1; lg:44; ht:7 );
begin
  EmpileFld;
  if StrError<>'' then
    begin
    PushZn(Zn);
    ClrZn(Zn,CWind);
    CCdrZn(Zn,CDRNORM,CCadre);
    WrtScr(' '+StrError+' ',x-1+CentralPos(length(StrError),42),y+1,CChoix);
    end
  else
    begin
    PushZn(Zn2);
    ClrZn(Zn2,CWind);
    CCdrZn(Zn2,CDRNORM,CCadre);
    end;
  WrtScr(CentreString(StrMsg1,40,32),x+2,y+3,FWind+TNet);
  WrtScr(CentreString(StrMsg2,40,32),x+2,y+4,FWind+TNet);
  if (Gadget and E_ABANDON)<>0 then
    begin
      WrtScr(' ABANDON ',x+2,y+6,CChoix);
      ChsFld(42);
    end
  else
    if (Gadget and E_NON)<>0 then
      begin
      WrtScr('   NON   ',x+2,y+6,CChoix);
      ChsFld(42);
      end;
  if (Gadget and E_REPRISE)<>0 then
    begin
      WrtScr(' REPRISE ',x+18,y+6,CChoix);
      ChsFld(41);
    end;
  if (Gadget and E_OK)<>0 then
    begin
      WrtScr('   OK   ',x+34,y+6,CChoix);
      Field[40].x := 52;
      Field[40].long := 8;
      ChsFld(40);
    end
  else
    if (Gadget and E_IGNORE)<>0 then
      begin
      WrtScr('  SUITE  ',x+33,y+6,CChoix);
      ChsFld(40);
      end
    else
      if (Gadget and E_OUI)<>0 then
        begin
        WrtScr('   OUI   ',x+33,y+6,CChoix);
        ChsFld(40);
        end;
  EndBoucle := false;
  PY := PYhaut; {  permet de desactiver l'ecran compo  }
  PYhaut := ScreenHigh;
  repeat
    if Interaction then
      begin
        if Key=#0 then
          begin
            case inter.SelectField of
              40 : begin
                     Result := E_OK;
                     EndBoucle := true;
                   end;
              41 : begin
                     Result := E_REPRISE;
                     EndBoucle := true;
                   end;
              42 : begin
                     Result := E_ABANDON;
                     EndBoucle := true;
                   end;
            else NoFieldLand;
            end; {  case of  }
          end
        Else
         If Not(Funct) Then
          Begin
           Case UpCase(Key) Of
            #13 :
             Begin
              If (Gadget And (E_OK Or E_REPRISE))<>E_REPRISE Then
               Begin
                Result := E_OK;
                EndBoucle := TRUE;
               End
              Else
               Begin
                Result := E_REPRISE;
                EndBoucle := TRUE;
               End;
             End;
            #27 :
             Begin
              Result := E_ABANDON;
              EndBoucle := true;
             End;
            'O' : If (Gadget And (E_OK Or E_OUI))<>0 Then
             Begin
              Result := E_OK;
              EndBoucle := TRUE;
             End;
            'N' : If (Gadget And E_NON)<>0 Then
             Begin
              Result := E_ABANDON;
              EndBoucle := TRUE;
             End;
            'R' : If (Gadget And E_REPRISE)<>0 Then
             Begin
              Result := E_REPRISE;
              EndBoucle := TRUE;
             End;
            'S' : If (Gadget And E_IGNORE)<>0 Then
             Begin
              Result := E_OK;
              EndBoucle := TRUE;
             End;
            'A' : If (Gadget And E_ABANDON)<>0 Then
             Begin
              Result := E_ABANDON;
              EndBoucle := TRUE;
             End;
           Else TheBeep;
           End;
          End
         Else TheBeep;
      end;
  until EndBoucle;
  Field[40].x := 51;
  Field[40].long := 9;
  PYhaut := PY;
  PopZn;
  DepileFld;
  WindError := Result;
end;


Function  AbortRequest : Boolean;
Begin
 ViewKey;
 If (Key<>#0) Then
  If (Funct=FALSE) And (Key=#27) Then
   Begin
    AbortRequest := WindError('','Souhaitez-vous interrompre',
                                 'l''opration en cours ?',E_NON+E_OUI)=E_OK;
   End
  Else
   Begin
    Beep;
    AbortRequest := FALSE;
   End
 Else AbortRequest := FALSE;
End;


Function  WaitOutEmpty : Boolean;
Begin
 While Mntl.TransmitCount>0 Do
  If AbortRequest Then
   Begin
    WaitOutEmpty := FALSE;
    Exit;
   End;
 WaitOutEmpty := TRUE;
End;



procedure MenuGauche;
var index : byte;
begin
  WrtScr('͸',0,0,CSep);
  for index := 1 to 23 do WrtScr('                  ',0,index,CSep);
  WrtScr(';',0,24,CSep);
  if not(Mouse) then WriteMouseStr;
end;

procedure BasMenuDroit;
var index : byte;
begin
  for index := 3 to 23 do WrtScr('                  ',60,index,CSep);
end;

procedure MenuDroit;
begin
  WrtScr('͸',60,0,CSep);
  WrtScr('                 ',60,1,CSep);
  WrtScr('͵',60,2,CSep);
  BasMenuDroit;
  WrtScr(';',60,24,CSep);
end;

procedure MenuHaut;
begin
  WrtScr(FillString(40,32),20,0,TSoNet);
  WrtDt(67,58,0,FHi); {  C  }
end;


Procedure MenuBas;  { si EGA/VGA }
Const Zn : Zn_Rec = (x:0; y:25; lg:80; ht:3);
Var i : Byte;
    j : Byte;
    (*
    CCadre : Byte;
    *)
Begin
 (*
 CCadre := CSep;
 *)
 If VideoEGA Then
  Begin
   ClrZn(Zn,CWind);
   CCdrZn(Zn,CDRDOUBLE,CCadre);
   WrtScr('Min.|Gra.|Inv.|DRCS|Coul|Max.',Zn.x+1,Zn.y+1,CDisp);
   For i := 1 To 5 Do
    Begin
     j := Zn.x+(i*5);
     (*
     WrtDt(Byte(''),j,Zn.y,CCadre);
     *)
     WrtDt(Byte(''),j,Zn.y+1,CCadre);
     (*
     WrtDt(Byte(''),j,Zn.y+2,CCadre);
     *)
    End;
   WrtDt(Byte(''),5*6,Zn.y+0,CCadre);
   WrtDt(Byte(''),5*6,Zn.y+1,CCadre);
   WrtDt(Byte(''),5*6,Zn.y+2,CCadre);
   (*
   WrtScr('[MIN.] Graph.'+#16+'Inv.'+#16+'DRCS'+#16+'Coul. [MAX.]',Zn.x+1,Zn.y+1,CDisp);
   *)
   If VideoVga Then
    Begin
     WrtScr('Coul/Gris',5*6+1,Zn.y+1,CDisp);
    End;
   WrtDt(Byte(''),5*6+1+9,Zn.y+0,CCadre);
   WrtDt(Byte(''),5*6+1+9,Zn.y+1,CCadre);
   WrtDt(Byte(''),5*6+1+9,Zn.y+2,CCadre);
   WrtScr('Tl.DRCS',5*6+2+9,Zn.y+1,CDisp);
   WrtDt(Byte(''),5*6+2+9*2,Zn.y+0,CCadre);
   WrtDt(Byte(''),5*6+2+9*2,Zn.y+1,CCadre);
   WrtDt(Byte(''),5*6+2+9*2,Zn.y+2,CCadre);
  End;
End;


procedure MakeTrait(pos : byte; HowMany : shortint; pas : byte);
begin
  while(HowMany>0) do
    begin
      WrtScr('Ĵ',60,pos,CSep);
      Dec(HowMany);
      Inc(pos,pas);
    end;
end;

procedure ShowTitle(texte : string);
begin
  WrtScr(CentreString(texte,18,32),61,3,SurEvidenceField);
  WrtScr('͵',60,4,CSep);
end;

var  StrMenu : ^StrMenu_ref;

procedure NewMenu(titre : string; var point; NbreChoix : byte);
var index : byte;
const Zn : Zn_Rec = ( x:60; y:3; lg:20; ht:21 );
begin
  EmpileFld;
  PushZn(Zn);
  BasMenuDroit;
  ShowTitle(titre);
  ChsFld(19);
  Fld[1].Select := true; {  on fait croire  }
  if NbreChoix>0 then
    begin
      StrMenu := @point;
      MakeTrait(6,NbreChoix,2);
      for index := 1 to NbreChoix do
        begin
          WrtScr(CentreString(StrMenu^[index],18,32),61,5+(index-1)*2,CDisp);
          ChsFld(21+(index-1)*2);
        end;
    end
  else
    StrMenu := nil;
end;

procedure EndNewMenu;
begin
  FieldOff;

  PopZn;
  DepileFld;
end;

function InputString(var texte : string; var c_pos : word; max,lg_chp,col,ligne : byte) : boolean;
{ pos_central=position caractre ou positionner le curseur ... }
var tempo,OfsX : integer;
    EndBoucle : boolean;
    index : byte;
    pos : integer;
    r   : word;
type Car_Rec = record
         car : byte;
         att : byte;
       end;
var CarLeft,
    CarRight,
    FleLeft,
    FleRight : Car_Rec;
  procedure InChamp;
  var buf   : string;
  begin
    FillChar(buf[1],lg_chp,32);
    buf[0] := char(lg_chp);
    move(texte[r+1],buf[1],length(texte)-r);
    WrtScr(buf,col,ligne,TNet);

    if r>0 then ToScr(@FleLeft,col-1,ligne,1)
    else toScr(@CarLeft,col-1,ligne,1);
    if length(texte)>(r+lg_chp) then ToScr(@FleRight,col+lg_chp,ligne,1)
    else toScr(@CarRight,col+lg_chp,ligne,1);
  end;

begin
  FromScr(@CarLeft,col-1,ligne,1);
  FromScr(@CarRight,col+lg_chp,ligne,1);
  FleLeft.car := 17;
  FleLeft.att := (CarLeft.att and not(15+128)) or THyNet;
  FleRight.car := 16;
  FleRight.att := (CarRight.att and not(15+128)) or THyNet;

  EndBoucle := false;
  if c_pos=0 then pos := 0
  else pos := c_pos-1;
  if pos>length(texte) then pos := length(texte);

  if pos<(lg_chp div 2) then r := 0
  else
    if pos+(lg_chp div 2)<length(texte) then r := pos-(lg_chp div 2)
    else
      if length(texte)<lg_chp then r := 0
      else
        begin
          r := (length(texte)-lg_chp); { (pos-lg_chp+1); }
          if pos=length(texte) then inc(r);
        end;
  repeat
{    WrtScr('"'+texte+'"',0,0,TNet);
    GotoXY(1,10);
    write('length(texte)=',length(texte),' pos=',pos,' r=',r,' max=',max);
    }
    InChamp;
    OfsX := (pos-r)+1;
    GotoXY(col+OfsX,ligne+1);
      GetKey;
      if Not(FUNCT) then
        case key of
          #9 : begin { tab }
                 if pos mod 8=0 then inc(pos,8)
                 else pos := (pos div 8)*8+8;
                 if pos>length(texte) then pos := length(texte);
                 if (pos-r+1)>lg_chp then r := (pos-lg_chp+1);
               end;
          #8 : begin {  del  }
                 if pos>0 then
                   begin
                     if pos<length(texte) then
                       move(texte[pos+1],texte[pos],length(texte)-pos);
                     dec(texte[0]);
                     dec(pos);
                     if (r>0) and (r>=pos) then dec(r);
                   end;
               end;
          #13 : begin {  return  }
                  EndBoucle := true;
                end;
          #25 : begin {  CTRL+Y  }
                  pos := 0;
                  r := 0;
                  texte := '';
                end;
          #27 : begin {  ESC  }
                  EndBoucle := true;
                end;
          #32..#255 : begin
                        if pos<max then
                          begin
                            inc(pos);
                            texte[pos] := key;
                            if length(texte)<pos then texte[0] := char(pos);
                            if (pos-r+1)>lg_chp then inc(r);
                          end;
                      end;
        end {  case of  }
      else { funct }
        case key of
          #15: begin { shift tab }
                 if pos mod 8=0 then dec(pos,8)
                 else dec(pos,pos mod 8);
                 if pos<0 then pos := 0;
                 if r>pos then r := pos;
               end;
          #71: begin { Home }
                 pos := 0;
                 r   := 0;
               end;
          #75: begin { <- }
                 if pos>0 then
                   begin
                     dec(pos);
                     if (r>0) and (r>pos) then dec(r);
                   end;
               end;
          #77: begin { -> }
                 if pos<length(texte) then
                   begin
                     inc(pos);
                     if (pos-r+1)>lg_chp then inc(r);
                   end;
               end;
          #79: begin { End }
                 pos := length(texte);
                 if pos>=lg_chp then r := (pos-lg_chp+1) else r := 0;
               end;
          #82: begin { Ins }
                 if length(texte)<max then
                   begin
                     move(texte[pos+1],texte[pos+2],length(texte)-(pos));
                     texte[pos+1] := '';
                     inc(texte[0]);
                   end;
               end;
          #83: begin { del }
                 if pos<length(texte) then
                   begin
                     if pos+1<length(texte) then
                       move(texte[pos+2],texte[pos+1],length(texte)-(pos+1));
                     dec(texte[0]);
                   end;
               end;
        end;
  until EndBoucle;
  { suppression des vides }
  r := 1;
  while r<=length(texte) do
    begin
      if (texte[r]='') then
        begin
          move(texte[r+1],texte[r],length(texte)-r);
          dec(texte[0]);
        end
      else inc(r);
    end;
  c_pos := pos+1;
  InputString := key=#13;

  ToScr(@CarLeft,col-1,ligne,1);
  ToScr(@CarRight,col+lg_chp,ligne,1);
end;


Function WaitInStr( Texte : String; TiNoCode, TiMax : Word;
                    Var Res : String ) : Boolean;
Var iRead : Byte;
    TiDeb : Longint;
    TiNo  : Longint;
    Ti    : Longint;
    c     : Char;
Begin
 iRead := 0;
 TiDeb := GetC18;

 While iRead<Length(Texte) Do
  Begin
   TiNo := GetC18;
   Repeat
    Ti := GetC18;
    If ((Ti-TiNo)>=TiNoCode) Or ((Ti-TiDeb)>=TiMax) Then
     Begin
      WaitInStr := FALSE;
      Exit;
     End;
   Until Mntl.ReceiveChar(c) And (c<>#0);  { Ignore les 0 }

   Inc(iRead);
   If Not((Texte[iRead]=#0) Or (Texte[iRead]=c)) Then { Recommencer ! }
    If (Texte[1]=#0) Or (Texte[1]=c) Then iRead := 1 Else iRead := 0
   Else
    Begin
     Res[iRead] := c;
    End;
  End;

 Res[0] := Texte[0];
 WaitInStr := TRUE;
End;


Function _CalcC18Delay( Len : Word; Speed : Word; Slow : Boolean ) : Word;
Var x : Word;
Begin
 x := 11520 Div TabSpeed[Speed].BD;
 x := ((Len+2+2)*18) Div x;
 If Slow Then Inc(x,6) Else Inc(x,3);
 _CalcC18Delay := x;
End;

Function CalcC18Delay( Len : Word ) : Word;
Begin
 CalcC18Delay := _CalcC18Delay(Len,Cfg.Speed,Cfg.Slow);
End;


Function MinDetect( WantSpeed : Byte; Slow, AutoSeek : Boolean ) : Boolean;
Const OrderRank : Array[0..NbSpeed-1] of byte =
        (Speed1200,Speed4800,Speed9600,Speed300,Speed75);
Var SpeedRank, SpeedCourant : Byte;
    i         : Byte;
    TabUse    : Array[0..NbSpeed-1] Of Boolean;
    x         : Word;
    Res       : String;
begin
 For i := 0 To NbSpeed-1 Do TabUse[i] := FALSE;
 SpeedRank := 0;
 SpeedCourant := WantSpeed;

 While TRUE Do
  Begin
   TabUse[SpeedCourant] := TRUE;
   Mntl.Clear;
   Mntl.SetBaud(TabSpeed[SpeedCourant].BD);
   { Demande status du terminal }
   Mntl.Write(#$0#$0#$0#$0+MPRO1+#$70#$0#$0#$0#$0);
   WaitOutEmpty;

   { attendre le status de module receveur prise }

   x := _CalcC18Delay(4,SpeedCourant,Slow);

   If WaitInStr( MPRO2+#$71#$00, x, x*4, Res) Then
    Begin
     If WantSpeed=SpeedCourant Then
      Begin
       Cfg.Speed := SpeedCourant;
       Cfg.Slow  := Cfg.Slow Or Slow;
       MinDetect := TRUE;
       Exit;
      End;

     If LastSpeed=SPEED_NIL Then LastSpeed := SpeedCourant;

     { change la vitesse }

     Mntl.Write(#0#0#0#0+MPRO2+Char($6B)+TabSpeed[WantSpeed].CSpeed);
     WaitOutEmpty;
     If Slow Then Delay(400) Else Delay(200);

     SpeedCourant := WantSpeed;
    End
   Else
    If LastSpeed<>SPEED_NIL Then
     If Not(AutoSeek) Or (WantSpeed=Speed1200) Then
      Begin
       MinDetect := FALSE;
       Exit;
      End
     Else { recherche automatique }
      Begin
       If WantSpeed>Speed1200 Then Dec(WantSpeed)
       Else Inc(WantSpeed);
       SpeedCourant := LastSpeed;
      End
    Else
     Begin
      While TabUse[OrderRank[SpeedRank]] Do
       Begin
        Inc(SpeedRank);
        If SpeedRank>=NbSpeed Then
         Begin
          MinDetect := FALSE;
          Exit;
         End;
       End;
      SpeedCourant := OrderRank[SpeedRank];
     End;
  End;
End;


Function MinStatusTerm( Var St : Byte ) : Boolean;
Var Res : String;
    x   : Word;
Begin
 { Demande status du terminal }
 Mntl.Write(MPRO1+#$70);
 WaitOutEmpty;

 { attendre le status de module receveur prise }

 x := CalcC18Delay(4);

 If WaitInStr( MPRO2+#$71#$00, x, x*4, Res ) Then
  Begin
   St := Byte(Res[4]);
   MinStatusTerm := TRUE;
  End
 Else MinStatusTerm := FALSE;
End;


Function  MinOnLine : Boolean;
Var St : Byte;
Begin
 MinConnected := MinStatusTerm(St) And (St And 8<>0);
 MinOnLine := MinConnected;
End;


Procedure MinRestoreSpeed;
Begin
 If LastSpeed<>SPEED_NIL Then
  Begin
   Mntl.Write(#0#0#0#0+MPRO2+Char($6B)+TabSpeed[LastSpeed].CSpeed);

   WaitOutEmpty;

   Delay(200);
  End;
End;



Procedure MinInitAffichage;
Begin
 Mntl.Write(#0#0#0#0+          { prpare le terrain }
            Modem_Off_Ecran+
            Modem_Off_Prise+
            Prise_Off_Modem+
            Prise_On_Ecran+
            Clavier_Off_Prise+
            Clavier_Off_Ecran+
            Clavier_Off_Modem);
 WaitOutEmpty;
End;



Procedure MinInitEmulation;
Begin
 Mntl.Write(#0#0#0#0+
            Modem_On_Ecran+
            Modem_On_Prise+
            Clavier_Off_Ecran+
            Clavier_Off_Prise+
            Clavier_On_Modem+
            Prise_Off_Ecran+
            Prise_On_Modem
           );
 WaitOutEmpty;
End;


Procedure MinReset;
Begin
 Mntl.Clear;
 Mntl.Write(#0#0#0#0+MPROReset);
 MinInitAffichage;
 Mntl.Write(#$1B#$3B#$6A#$58#$41+  {  fin du mode veille }
            #31'@A'#24#12);       { Vide l'ecran }
 WaitOutEmpty;
 Mntl.Clear;
End;


Procedure DetectTpMini;
Var Res : String;
    x   : Word;
    i   : Word;
Begin
 { Demande le type de minitel }
 Mntl.Write(#27#$39#$7B);
 WaitOutEmpty;

 { attendre le status de module receveur prise }

 x := CalcC18Delay(5);

 If WaitInStr( #1#0#0#0#4, x, x*4, Res ) Then
  Begin
   For i := 1 To NbGenreMini Do
    If TabGenreMini[i].Id=Res[3] Then
     Begin
      CFG.TpMini := TabGenreMini[i].Tp; { genre trouv }
      Exit;
     End;
  End;
End;


Procedure KeepMinitel;
Var c : Char;
Begin
  If Not(MinOnLine) Then
   Begin
    Mntl.Clear;
    Mntl.Write(#0#0#0#0+MPRO1+Char($7F));
    WaitOutEmpty;
    Mntl.Clear;
   End
  Else MinInitEmulation;  { met en place les aiguillages connect! }

  MinRestoreSpeed;
End;



function CompoField : boolean;
{ attention: on reprend certaine variable de Interaction }
begin
  NumField := CurX+CurY*40;
  inter.BtnGauche := ButtonL;
  repeat
    MouseStatus;
    GotoXY(MouseC+1,MouseL+1);
    if (MouseC>19+PXhaut) and (MouseC<21+PXbas) and
       (MouseL>=PYhaut) and (MouseL<=PYbas) then
      begin { dans la page de compo }
        CurX := MouseC-20; CurY := MouseL;
      end
    else CurY := ScreenHigh; { valeur bidon }
    CurSitu;
    ViewKey; { bidon car on ne tient pas compte des touches enfonces }
  until not(ButtonL) and not(ButtonR);
  { bouton relache }
  if (CurX+CurY*40)=NumField then
    begin { au but }
      CompoField := true;
      exit;
    end
  else
    begin { a cote }
      CompoField := false;
      exit;
    end;
 end;



Procedure Rien; Far;
Begin
End;

Function  Rien2( Var field1 : fields_map; Data : Pointer ) : Boolean; Far;
Begin
End;

begin
  LongFldPile := 0;
  InterProc   := Rien;
  FixeField1  := Rien2;
  DataField1  := NIL;
  MouseReady  := FALSE;
end.
